{ͻ
 
 ۱۱߱۱۱߱
 ۲۲߲ܲ۲۲
 ۱۱۱ܱ۱۱۱
 
      Pitspawn666.tripod.com     
 ͼ}
PROGRAM AlphaOne;
USES Crt, Dos;
TYPE
  BlockTB=ARRAY[1..255,0..255] OF BYTE;

VAR AlphaLEV,INum          : BYTE;
    i1,i2,i3,Err           : WORD;
    PCXFile,OUTFile,TmpSTR : STRING;
    SR                     : SEARCHREC;
    XFile                  : FILE;
    RGB                    : ARRAY[0..255,1..3] OF BYTE;
    Alpha                  : ARRAY[1..3] OF REAL;
    Max,Diff               : ARRAY[1..3] OF BYTE;
    BIGTable               : ^BlockTB;

PROCEDURE SetRGB(R,G,B,Index:BYTE); ASSEMBLER;
ASM
     MOV  dx, 968
     MOV  al, [Index]
     OUT  dx, al
     INC  dx
     MOV  al, [R]
     OUT  dx, al
     MOV  al, [G]
     OUT  dx, al
     MOV  al, [B]
     OUT  dx, al
END;
FUNCTION Centre(x:STRING):BYTE;
BEGIN
  Centre := Length(x) DIV 2;
END;
PROCEDURE TitleBar(x:STRING; A,B:BYTE);
BEGIN
  TextColor(A); TextBackground(B);
  FOR i1 := 0 TO 79 DO mem[$b800:(i1 SHL 1)+1] := (B SHL 4)+A;
  GotoXY(40-Centre(x),1); Writeln(x);
END;
PROCEDURE ExtractPalette;
BEGIN
  Assign(XFile,PCXFile);
  Reset(XFile,1);
    Seek(XFile,SR.Size-768);
    BlockRead(XFile,RGB,768,Err);
  Close(XFile);
END;
PROCEDURE GenerateTable;
BEGIN
  FOR i1 := 1 TO 255 DO BEGIN
    FOR i2 := 0 TO 255 DO BEGIN
      Alpha[1] := RGB[i1,1]+(((RGB[i2,1]-RGB[i1,1])/100)*AlphaLEV);
      Alpha[2] := RGB[i1,2]+(((RGB[i2,2]-RGB[i1,2])/100)*AlphaLEV);
      Alpha[3] := RGB[i1,3]+(((RGB[i2,3]-RGB[i1,3])/100)*AlphaLEV);
      IF Alpha[1] > 255 THEN Alpha[1] := 255;
      IF Alpha[2] > 255 THEN Alpha[2] := 255;
      IF Alpha[3] > 255 THEN Alpha[3] := 255;
      IF Alpha[1] < 0 THEN Alpha[1] := 0;
      IF Alpha[2] < 0 THEN Alpha[2] := 0;
      IF Alpha[3] < 0 THEN Alpha[3] := 0;
      Max[1] := 255; Max[2] := 255; Max[3] := 255;
      FOR i3 := 0 TO 255 DO BEGIN
        Diff[1] := ROUND(ABS(RGB[i3,1]-Alpha[1]));
        Diff[2] := ROUND(ABS(RGB[i3,2]-Alpha[2]));
        Diff[3] := ROUND(ABS(RGB[i3,3]-Alpha[3]));
        IF (Diff[1]<Max[1]) AND (Diff[2]<Max[2]) AND (Diff[3]<Max[3]) THEN BEGIN
          IF (Diff[1]>Diff[2]) AND (Diff[1]>Diff[3]) THEN BEGIN
            Max[1] := Diff[1];
            INum := i3;
          END;
          IF (Diff[2]>Diff[1]) AND (Diff[2]>Diff[3]) THEN BEGIN
            Max[2] := Diff[2];
            INum := i3;
          END;
          IF (Diff[3]>Diff[1]) AND (Diff[3]>Diff[2]) THEN BEGIN
            Max[3] := Diff[3];
            INum := i3;
          END;
        END;
      END;
      BIGTable^[i1,i2] := INum;
    END;
    Write('.');
  END;
END;
PROCEDURE InitVGA; ASSEMBLER;
ASM
     MOV  ax, 13h
     INT  10h
END;
PROCEDURE DrawBlock;
BEGIN
  FOR i1 := 0 TO 255 DO SetRGB(RGB[i1,1] div 4,RGB[i1,2] div 4,RGB[i1,3] div 4,i1);
  FOR i1 := 1 TO 199 DO BEGIN
    FOR i2 := 0 TO 255 DO BEGIN
      mem[$a000:(320*i1)+i2] := BigTable^[i1,i2];
    END;
  END;
END;
PROCEDURE Menu;
BEGIN
  TextColor(7); TextBackground(0); ClrScr;
  TitleBar('AlphaOne...(Pitspawn666.tripod.com)',15,1);
  TextColor(7); TextBackground(0);
  Write('This program is designed to get a single 255x256x1 Alpha level table.');
  Write('  Unfortunately, because of the way TP handles memory, it cannot hold an entire ');
  Write('64Kb memory block.  This means that the array held in memory is missing the first ');
  Writeln('colour 0 match.  You can get around this problem by swapping 0-->X to X-->0.');
  Writeln;
  Write('Enter PCX filename             : ');
  Readln(PCXFile);
  FindFirst(PCXFile,0,SR);
  IF DosError=0 THEN BEGIN
    Write('Enter Alpha Intensity (0-100%) : ');
    REPEAT
      GotoXY(34,8); ClrEOL;
      Readln(TmpSTR);
      Val(TmpSTR,AlphaLEV,Err);
    UNTIL (Err=0) AND ((AlphaLEV>=0) AND (AlphaLEV<=100));
    Write('Extracting Palette...');
    ExtractPalette;
    IF Err=768 THEN BEGIN
      Writeln('Done');
      Write('Enter Table Output             : ');
      Readln(OUTFile);
      Write('Generating Table ');
      GenerateTable;
      Writeln('Done');
      Writeln('Writing file...');
      Assign(XFile,OUTFile);
        Rewrite(XFile,1);
        Reset(XFile,1);
          BlockWrite(XFile,Alpha,1);
          BlockWrite(XFile,BIGTable^,SizeOf(BIGTable^));
        Close(XFile);
      InitVGA;
      DrawBlock;
      Readkey;
    END ELSE BEGIN
      Writeln('PCX data error.');
      Readkey;
    END;
  END ELSE BEGIN
    Write('PCXFile access error.');
    Readkey;
  END;
END;

BEGIN
  New(BIGTable);
  Menu;
  Dispose(BIGTable);
END.